package it.arnaldo.unibs.tamagolem;

import java.util.ArrayList;

public class Player {
    private final String name;
    private final ArrayList<TamaGolem> tamaGolems;

    public Player(String name) {
        this.name = name;
        this.tamaGolems = new ArrayList<>();
    }

    public String getName() {
        return name;
    }

    public ArrayList<TamaGolem> getTamaGolems() {
        return tamaGolems;
    }

    public TamaGolem getNextTamaGolem() {
        if (tamaGolems.isEmpty()) {
            return null;
        } else {
            return tamaGolems.get(0);
        }
    }

    public void addTamaGolem(TamaGolem t) {
        tamaGolems.add(t);
    }

    public void removeTamaGolem(TamaGolem t) {
        tamaGolems.remove(t);
    }

    public boolean isAlive() {
        for (TamaGolem golem : tamaGolems) {
            if (golem.getLifePoints() > 0) {
                return true;
            }
        }

        return false;
    }


}
