package it.arnaldo.unibs.tamagolem;

import java.util.ArrayDeque;
import java.util.Deque;

public class TamaGolem {
    private final Deque<Element> elementalStones;
    private int lifePoints;

    public TamaGolem(int lifePoints) {
        this.lifePoints = lifePoints;
        this.elementalStones = new ArrayDeque<>();
    }

    public void addElementalStone(Element stone) {
        elementalStones.add(stone);
    }

    public Element useElementalStone() {
        if (!elementalStones.isEmpty()) {
            Element removedStone = elementalStones.removeFirst();
            elementalStones.add(removedStone);
            return removedStone;
        }
        return null;
    }

    public int getLifePoints() {
        return lifePoints;
    }

    public boolean getDamage(int damage) {
        lifePoints -= damage;
        return lifePoints <= 0;
    }

    public boolean isAlive() {
        return lifePoints > 0;
    }

    @Override
    public String toString() {
        return "LP: " + lifePoints + ", Elemental stones:" + elementalStones.toString();
    }

    public void print() {
        System.out.println(toString());

    }
}
